From 5f3168c509e091e05c5f9f3145b6de1e78ef5a4c Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 22 2017 18:23:01 +0000
Subject: [PATCH 881/1001] Create the SSE server with Twisted


---

diff --git a/Vagrantfile.example b/Vagrantfile.example
index 5caa591..5310d5a 100644
--- a/Vagrantfile.example
+++ b/Vagrantfile.example
@@ -8,6 +8,7 @@ Vagrant.configure(VAGRANTFILE_API_VERSION) do |config|
 
  # Forward traffic on the host to the development server on the guest
  config.vm.network "forwarded_port", guest: 5000, host: 5000
+ config.vm.network "forwarded_port", guest: 8080, host: 8080
 
  # Comment out if you don't want Vagrant to add and remove entries from /etc/hosts for each VM.
  # requires the vagrant-hostmanager plugin to be installed
diff --git a/ansible/roles/hubs/files/nginx_proxy_params b/ansible/roles/hubs/files/nginx_proxy_params
new file mode 100644
index 0000000..f4ebcd7
--- /dev/null
+++ b/ansible/roles/hubs/files/nginx_proxy_params
@@ -0,0 +1,6 @@
+proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
+proxy_set_header X-Forwarded-Proto $scheme;
+proxy_set_header Host $http_host;
+# we don't want nginx trying to do something clever with
+# redirects, we set the Host: header above already.
+proxy_redirect off;
diff --git a/hubs/backend/sse_server.py b/hubs/backend/sse_server.py
new file mode 100644
index 0000000..781ddb2
--- /dev/null
+++ b/hubs/backend/sse_server.py
@@ -0,0 +1,194 @@
+#!/usr/bin/env python
+# coding: utf-8
+
+from __future__ import unicode_literals, print_function
+
+import json
+
+import txredisapi as redis
+
+from twisted.application import service
+from twisted.web import server, resource
+from twisted.internet import reactor, defer
+from twisted.logger import (
+    Logger, globalLogBeginner, ILogObserver, formatEvent)
+from zope.interface import provider
+
+import hubs.app
+
+
+log = Logger()
+fedmsg_config = hubs.app.fedmsg_config
+
+REDIS_CONF = {
+    'host': fedmsg_config.get('hubs.redis.host', 'localhost'),
+    'port': fedmsg_config.get('hubs.redis.port', 6379),
+    'dbid': fedmsg_config.get('hubs.redis.db', 0),
+    'password': fedmsg_config.get('hubs.redis.password', None),
+}
+
+
+class RetaskQueue(object):
+    """
+    Compatibility class with https://github.com/kushaldas/retask/ using the
+    txredisapi non-blocking API for Redis.
+    """
+
+    def __init__(self, name, connection=None):
+        self.conn = connection or redis.lazyConnection(**REDIS_CONF)
+        self.name = "retaskqueue-{}".format(name)
+
+    def wait(self, wait_time=0):
+        def format_result(msg):
+            task = json.loads(msg[1])
+            return json.loads(task["_data"])
+        d = self.conn.brpop(self.name, wait_time)
+        d.addCallback(format_result)
+        d.addErrback(self._error_handler)
+        return d
+
+    def length(self):
+        d = self.conn.llen(self.name)
+        d.addErrback(self._error_handler)
+        return d
+
+    def _error_handler(self, failure):
+        failure.trap(redis.ConnectionError)
+        log.debug("Lost connection to Redis, will attempt to reconnect "
+                  "in the background.")
+        return None
+
+    def disconnect(self):
+        return self.conn.disconnect()
+
+
+class Subscribe(resource.Resource):
+    """
+    Twisted web resource allowing clients to subscribe to Redis messages.
+
+    The Redis messages will be broadcasted to all clients using the broadcast()
+    method.
+    """
+
+    isLeaf = True
+
+    def __init__(self):
+        resource.Resource.__init__(self)
+        self.subscribers = {}
+        self.allow_origin = fedmsg_config.get('hubs.sse.allow-origin', '*')
+
+    def render_GET(self, request):
+        """
+        Handle GET requests to this endpoint. Requests should be to
+        ``/[user|hub]/<target>/``.
+        """
+        # If the request ended in a trailing / the final path section is ''.
+        # This allows the trailing / on /<type>/<target>/ to be optional.
+        if request.postpath[-1] == '':
+            request.postpath.pop()
+        if len(request.postpath) != 2:
+            response = resource.ErrorPage(
+                status=400, brief="Bad request", detail="Bad request.")
+            return response.render(request)
+        target = "/".join([p.decode("utf-8") for p in request.postpath])
+
+        request.setHeader('Content-Type', 'text/event-stream; charset=utf-8')
+        request.setHeader('Access-Control-Allow-Origin', self.allow_origin)
+        request.setHeader('X-Accel-Buffering', 'no')
+        request.write(b"")
+        request.notifyFinish().addBoth(self.request_closed, request, target)
+
+        if target not in self.subscribers:
+            self.subscribers[target] = []  # first request to this target.
+        log.debug("New subscriber: {req}", req=request)
+        self.subscribers[target].append(request)
+        log.debug("There is now {count} subscribers to {target}.",
+                  target=target, count=len(self.subscribers[target]))
+
+        return server.NOT_DONE_YET
+
+    def broadcast(self, target, event, data):
+        log.debug("Received {event} message to broadcast to {target}: {data}",
+                  target=target, event=event, data=data)
+        target_subscribers = self.subscribers.get(target, [])
+        if not target_subscribers:
+            return
+        log.debug("Broadcasting to {num} requests.",
+                  num=len(target_subscribers))
+        for request in target_subscribers:
+            if event:
+                request.write("event: {}\r\n".format(event).encode("utf-8"))
+            request.write("data: {}\r\n".format(data).encode("utf-8"))
+            # The last CRLF is required to dispatch the event to the client.
+            request.write(b"\r\n")
+
+    def request_closed(self, err, request, target):
+        log.debug("Removing subscriber {subscriber} from {target}.",
+                  subscriber=request, target=target)
+        self.subscribers[target].remove(request)
+        log.debug("There is now {count} subscribers to {target}.",
+                  target=target, count=len(self.subscribers[target]))
+
+
+class RedisClientService(service.Service):
+
+    def __init__(self, broadcaster):
+        self.broadcaster = broadcaster
+        self.queue = None
+        self._stopping = False
+
+    @defer.inlineCallbacks
+    def process(self):
+        """
+        Get the data from the Redis queue and broadcast it.
+        """
+
+        backlog = yield self.queue.length()
+        log.info("Starting Redis task dispatcher with a backlog of {num} "
+                 "messages.", num=backlog)
+        while True:
+            task = yield self.queue.wait()
+            if task is None:
+                if self._stopping:
+                    break
+                log.debug("No task received, or connection lost.")
+                continue
+            try:
+                task = json.loads(task)
+            except ValueError:
+                log.warning("Invalid task received: {task!r}", task=task)
+                continue
+            log.debug("Task received: {task!r}", task=task)
+            if "target" not in task or "data" not in task:
+                log.warning("Invalid task received: {task!r}", task=task)
+                continue
+            self.broadcaster.broadcast(
+                task["target"], task.get("event"), task["data"])
+
+    def startService(self):
+        queue_name = fedmsg_config['hubs.sse.redis-queue-name']
+        self.queue = RetaskQueue(queue_name)
+        return reactor.callLater(0, self.process)
+
+    def stopService(self):
+        self._stopping = True
+        return self.queue.disconnect()
+
+
+def main():
+    @provider(ILogObserver)
+    def printingObserver(event):
+        print(formatEvent(event))
+    globalLogBeginner.beginLoggingTo(
+        [printingObserver], redirectStandardIO=False)
+    sub = Subscribe()
+    site = server.Site(sub)
+    port = int(hubs.app.app.config.get("SSE_URL", {}).get("port", 8080))
+    reactor.listenTCP(port, site)
+    redisclient = RedisClientService(sub)
+    redisclient.startService()
+    reactor.run()
+
+
+if __name__ == "__main__":
+    main()
diff --git a/hubs/backend/sse_server.tac b/hubs/backend/sse_server.tac
new file mode 100644
index 0000000..57dc41f
--- /dev/null
+++ b/hubs/backend/sse_server.tac
@@ -0,0 +1,39 @@
+# You can run this .tac file directly with:
+#    twistd -ny hubs/backend/sse_server.tac
+
+"""
+This is an example .tac file which starts a webserver on port 8080 and
+serves files from the current working directory.
+
+The important part of this, the part that makes it a .tac file, is
+the final root-level section, which sets up the object called 'application'
+which twistd will look for
+"""
+
+from __future__ import unicode_literals
+
+from twisted.application import service, internet
+from twisted.internet import reactor
+from twisted.web import server
+
+import hubs.app
+from hubs.backend.sse_server import Subscribe, RedisClientService
+
+
+sse_config = hubs.app.app.config.get("SSE_URL", {})
+WEB_PORT = int(sse_config.get("port", 8080))
+
+
+# this is the core part of any tac file, the creation of the root-level
+# application object
+application = service.Application("Hubs SSE Server")
+
+# Web server
+broadcaster = Subscribe()
+site = server.Site(broadcaster)
+web_service = internet.TCPServer(WEB_PORT, site)
+web_service.setServiceParent(application)
+
+# Redis client
+redis_service = RedisClientService(broadcaster)
+redis_service.setServiceParent(application)
diff --git a/hubs/backend/triage.py b/hubs/backend/triage.py
index 16bcbd1..b4a2c82 100755
--- a/hubs/backend/triage.py
+++ b/hubs/backend/triage.py
@@ -49,7 +49,8 @@ def triage(msg):
             return
 
     # Handle user notifications.
-    if ".fmn.notification." in topic:  # XXX: use the proper topic pattern when it's chosen
+    # XXX: use the proper topic pattern when it's chosen
+    if ".fmn.notification." in topic:
         yield retask.task.Task(json.dumps({
             'type': 'notification',
             'msg': msg,
@@ -79,6 +80,7 @@ def triage(msg):
                 yield retask.task.Task(json.dumps({
                     'type': 'widget-cache',
                     'idx': widget.idx,
+                    'hub': widget.hub.name,
                     'fn_name': fn_name,
                     'msg_id': msg['msg_id'],
                 }))
diff --git a/hubs/backend/worker.py b/hubs/backend/worker.py
index 5e82bda..363025a 100755
--- a/hubs/backend/worker.py
+++ b/hubs/backend/worker.py
@@ -31,6 +31,7 @@ import logging
 import logging.config
 import sys
 
+import fedmsg.meta
 import retask.queue
 
 import hubs.app
@@ -51,7 +52,6 @@ def widget_cache_work(widget_idx, fn_name):
     log.info("! Rebuilding cache for %r:%r" % (widget, fn_name))
     # Invalidate the cache...
     fn_class(widget).rebuild()
-    # TODO -- fire off an EventSource notice that we updated stuff
 
 
 def handle_widget_cache(widget_idx, fn_name):
@@ -78,7 +78,7 @@ def main(args=None):
     log.info("Worker starting, connecting to retask queue %r." % name)
     queue = retask.queue.Queue(name)
     queue.connect()
-    sse_name = fedmsg_config['hubs.redis.sse-queue-name']
+    sse_name = fedmsg_config['hubs.sse.redis-queue-name']
     log.info("Worker starting, connecting to retask queue %r." % sse_name)
     sse_queue = retask.queue.Queue(sse_name)
     sse_queue.connect()
@@ -96,13 +96,15 @@ def main(args=None):
                 sse_task = {
                     "event": "hubs:widget-updated",
                     "data": item["idx"],
+                    "target": "hub/{}".format(item["hub"]),
                 }
             elif item_type == "notification":
                 hubs.feed.on_new_notification(item["msg"])
-                username = fedmsg.meta.msg2agent(msg)
+                username = fedmsg.meta.msg2agent(item["msg"])
                 sse_task = {
                     "event": "hubs:new-notification",
                     "data": username,
+                    "target": "user/{}".format(username),
                 }
             if sse_task is not None:
                 sse_queue.enqueue(retask.task.Task(json.dumps(sse_task)))
diff --git a/hubs/default_config.py b/hubs/default_config.py
index 917840b..ab47804 100644
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -12,8 +12,9 @@ PROMOTED_GROUPS = [
 HUB_OF_THE_MONTH = 'commops'
 
 SSE_URL = {
+    # "host": "sse.example.com",
     "port": "8080",
-    "path": "/sse",
+    # "path": "/sse",
 }
 PLUS_PLUS_URL = 'http://localhost:5001/user/'
 PLUS_PLUS_TOKEN = 'thisismytoken'
diff --git a/hubs/default_fedmsg_config.py b/hubs/default_fedmsg_config.py
index 7cf088d..a7d1a3c 100644
--- a/hubs/default_fedmsg_config.py
+++ b/hubs/default_fedmsg_config.py
@@ -9,7 +9,7 @@ config = {
     # For communication between fedmsg-hub and the cache worker farm
     'hubs.redis.triage-queue-name': 'fedora-hubs-triage-queue',
     'hubs.redis.work-queue-name': 'fedora-hubs-work-queue',
-    'hubs.redis.sse-queue-name': 'fedora-hubs-sse-queue',
+    'hubs.sse.redis-queue-name': 'fedora-hubs-sse-queue',
 
     # Junk junk junk.. that we don't care about.  Drop it!
     'hubs.junk_suffixes': [
diff --git a/hubs/static/client/app/components/feed/ItemsGetter.jsx b/hubs/static/client/app/components/feed/ItemsGetter.jsx
index bfc51a8..75c50f9 100644
--- a/hubs/static/client/app/components/feed/ItemsGetter.jsx
+++ b/hubs/static/client/app/components/feed/ItemsGetter.jsx
@@ -33,6 +33,7 @@ export default class ItemsGetter extends React.Component {
   setupSSESource() {
     //if (!this.props.sseEventName || !this.props.handleSSEEvent) {
     if (!this.props.sse.eventName || !this.props.sse.shouldReload) {
+      console.log("SSE auto-update is disabled");
       // Auto-update is disabled.
       return;
     }
diff --git a/hubs/static/client/app/components/feed/Markup.jsx b/hubs/static/client/app/components/feed/Markup.jsx
index 16658eb..ad482e0 100644
--- a/hubs/static/client/app/components/feed/Markup.jsx
+++ b/hubs/static/client/app/components/feed/Markup.jsx
@@ -14,12 +14,14 @@ export default class Markup extends React.Component {
   }
 
   render() {
-    const timestamp = this.props.item.date_time ? (<TimeAgo date={this.props.item.date_time} />) : null;
+    const timestamp = this.props.item.end_time || this.props.item.timestamp;
 
     return (
       <div className="media-body align-self-center">
         <span dangerouslySetInnerHTML={this.createMarkup()}></span>
-        {timestamp}
+        <small className="text-muted float-right">
+          <TimeAgo date={timestamp * 1000} />
+        </small>
       </div>
     );
   }
diff --git a/hubs/static/client/app/widgets/feed/Widget.jsx b/hubs/static/client/app/widgets/feed/Widget.jsx
index ded612e..636daa2 100644
--- a/hubs/static/client/app/widgets/feed/Widget.jsx
+++ b/hubs/static/client/app/widgets/feed/Widget.jsx
@@ -23,7 +23,7 @@ export default class Widget extends React.Component {
         url={this.props.url}
         sse={{
           eventName: "hubs:widget-updated",
-          shouldReload: (idx) => (idx === this.props.widgetIdx),
+          shouldReload: (idx) => (parseInt(idx) === this.props.widgetIdx),
         }}
         handleData={this.handleServerData}
         >
diff --git a/hubs/static/js/utils.js b/hubs/static/js/utils.js
index 1f33870..2169c6b 100644
--- a/hubs/static/js/utils.js
+++ b/hubs/static/js/utils.js
@@ -41,6 +41,7 @@ function setup_sse(url) {
     var sseSource = new EventSource(url);
     sseSource.addEventListener("hubs:widget-updated", function(e) {
         var widget = $("#widget-" + e.data);
+        if (widget.length === 0) { return; }
         if (widget.find("div.card[data-disable-autoreload]").length !== 0) { return; }
         $.ajax({
             url: widget.attr("data-url"),
@@ -56,6 +57,16 @@ function setup_sse(url) {
             },
         });
     });
+    // On each message, switch the notification favicon to green for 15s.
+    sseSource.addEventListener("message", function(e) {
+        Notificon('#33ff00');  // green
+        setTimeout(function(){ Notificon(); }, 15000)
+    });
+    // On error, switch the notification favicon to red.
+    sseSource.addEventListener("error", function(e) {
+        Notificon('#eb361e');  // red
+        setTimeout(function(){ Notificon(); }, 15000)
+    });
     // Make it accessible by other components on the page.
     document.sseSource = sseSource;
   }
diff --git a/hubs/tests/hubs_test.cfg b/hubs/tests/hubs_test.cfg
index a910e72..bae6178 100644
--- a/hubs/tests/hubs_test.cfg
+++ b/hubs/tests/hubs_test.cfg
@@ -1,7 +1,8 @@
 ### Secret key for the Flask application
-SECRET_KEY='<The web application secret key>'
+SECRET_KEY = '<The web application secret key>'
 
 ### url to the database server:
+
 import os
 DB_URL = 'sqlite:///%s/test.db' % (os.path.dirname(os.path.abspath(__file__)))
 #DB_URL='sqlite:////tmp/fedocal_dev.sqlite'
@@ -11,3 +12,8 @@ OIDC_CLIENT_SECRETS = os.path.join(os.path.dirname(
     os.path.abspath(__file__)), 'client_secrets.json')
 
 SITE_ADMINS = ["admin"]
+
+SSE_URL = {
+    "port": "8080",
+    "path": "/sse",
+}
diff --git a/hubs/tests/test_view_utils.py b/hubs/tests/test_view_utils.py
index 6a6d116..ca49dac 100644
--- a/hubs/tests/test_view_utils.py
+++ b/hubs/tests/test_view_utils.py
@@ -89,28 +89,43 @@ class ViewUtilsTest(APPTest):
 
     def test_sse_url(self):
         with app.test_request_context():
-            self.assertEqual(get_sse_url(), "http://localhost:8080/sse")
+            self.assertEqual(get_sse_url(""), "http://localhost:8080/sse/")
+
+        with app.test_request_context():
+            self.assertEqual(
+                get_sse_url("hub/ralph"),
+                "http://localhost:8080/sse/hub/ralph")
 
         with app.test_request_context(base_url='http://hubs.example.com/'):
-            self.assertEqual(get_sse_url(), "http://hubs.example.com:8080/sse")
+            self.assertEqual(
+                get_sse_url("hub/ralph"),
+                "http://hubs.example.com:8080/sse/hub/ralph")
 
         with app.test_request_context(base_url='http://example.com/hubs'):
             self.assertEqual(flask.url_for("index"), "/hubs/")  # test validity
-            self.assertEqual(get_sse_url(), "http://example.com:8080/sse")
+            self.assertEqual(
+                get_sse_url("hub/ralph"),
+                "http://example.com:8080/sse/hub/ralph")
 
         with app.test_request_context(base_url='http://hubs.example.com/'):
             with app_config(app, {
                     "SSE_URL": {"host": "hubs-sse.example.com"}
                     }):
-                self.assertEqual(get_sse_url(), "http://hubs-sse.example.com/")
+                self.assertEqual(
+                    get_sse_url("hub/ralph"),
+                    "http://hubs-sse.example.com/hub/ralph")
 
         with app.test_request_context(base_url='http://hubs.example.com/'):
             with app_config(app, {
                     "SSE_URL": {"host": "hubs-sse.example.com",
                                 "port": 8080}
                     }):
-                self.assertEqual(get_sse_url(), "http://hubs-sse.example.com:8080/")
+                self.assertEqual(
+                    get_sse_url("hub/ralph"),
+                    "http://hubs-sse.example.com:8080/hub/ralph")
 
         with app.test_request_context(base_url='http://localhost/hubs'):
             with app_config(app, {"SSE_URL": {"host": "example.com"}}):
-                self.assertEqual(get_sse_url(), "http://example.com/")
+                self.assertEqual(
+                    get_sse_url("hub/ralph"),
+                    "http://example.com/hub/ralph")
diff --git a/hubs/utils/views.py b/hubs/utils/views.py
index 4a4c63a..50c5723 100644
--- a/hubs/utils/views.py
+++ b/hubs/utils/views.py
@@ -288,7 +288,7 @@ class RequestValidator(object):
         return values
 
 
-def get_sse_url():
+def get_sse_url(target):
     """Build the SSE URL."""
     # Avoid circular import with widgets.
     from hubs.app import app
@@ -302,7 +302,11 @@ def get_sse_url():
     netloc = host
     if port:
         netloc = "{}:{}".format(host, port)
-    path = urlparse.urljoin(base_url.path, conf.get("path", "/"))
+    path = conf.get("path", "")
+    if not path.endswith("/"):
+        path += "/"
+    path = urlparse.urljoin(base_url.path, path)
+    path = urlparse.urljoin(path, target)
     return urlparse.urlunsplit([
         conf.get("scheme") or base_url.scheme,
         netloc, path, "", "",
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 5496503..0616f05 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -22,7 +22,7 @@ def hub(name):
         hub=hub,
         widgets=widgets,
         edit=False,
-        sse_url=get_sse_url(),
+        sse_url=get_sse_url("hub/{}".format(hub.name)),
         )
 
 
diff --git a/hubs/views/user.py b/hubs/views/user.py
index a5cc00d..13e1313 100644
--- a/hubs/views/user.py
+++ b/hubs/views/user.py
@@ -1,15 +1,11 @@
 from __future__ import unicode_literals, absolute_import
 
 import flask
-import json
 import hubs.models
 import hubs.feed
 
 from hubs.app import app
-from hubs.utils.views import (
-    login_required, get_hub, get_sse_url, get_visible_widgets,
-    require_hub_access,
-    )
+from hubs.utils.views import login_required, get_hub, get_sse_url
 
 
 @app.route('/stream')
@@ -18,12 +14,10 @@ from hubs.utils.views import (
 def stream():
     username = flask.g.auth.user.username
     hub = get_hub(username)
-    widgets = get_visible_widgets(hub)
     return flask.render_template(
         'stream.html',
         hub=hub,
-        widgets=widgets,
-        sse_url=get_sse_url(),
+        sse_url=get_sse_url("user/{}".format(username)),
     )
 
 
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index eb0db3c..9010ad1 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -3,8 +3,6 @@ from __future__ import unicode_literals, absolute_import
 
 import logging
 
-import hubs.feed
-from hubs.views.utils import get_sse_url
 from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
@@ -39,7 +37,6 @@ class BaseView(WidgetView):
     def get_context(self, instance, *args, **kwargs):
         return dict(
             title=self.widget.label,
-            sse_url=get_sse_url(),
             disable_autoreload=True,
             )
 
diff --git a/systemd/hubs-sse.service b/systemd/hubs-sse.service
new file mode 100644
index 0000000..1120a4f
--- /dev/null
+++ b/systemd/hubs-sse.service
@@ -0,0 +1,19 @@
+[Unit]
+Description=fedora-hubs SSE server
+After=network.target
+Documentation=https://pagure.io/fedora-hubs/
+
+[Service]
+ExecStart= \
+    twistd -l - --pidfile= \
+    -ny /srv/hubs/fedora-hubs/hubs/backend/sse_server.tac
+WorkingDirectory=/srv/hubs/fedora-hubs/
+PIDFile=/run/hubs-sse.pid
+Type=simple
+User=root
+Group=root
+Restart=on-failure
+
+[Install]
+WantedBy=multi-user.target
+

